/*******************************************************
This program was created by the
CodeWizardAVR V3.12 Advanced
Automatic Program Generator
 Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 0.0.1 b
Date    : 26.01.2015
Author  : NoM@d
Company : 
Comments: 


Chip type               : ATmega8A
Program type            : Application
AVR Core Clock frequency: 1,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*******************************************************/

#include <mega8.h>

#include <delay.h>
#include <stdio.h>

// 1 Wire Bus interface functions
#include <1wire.h>

// DS1820 Temperature Sensor functions
#include <ds18b20.h>


// Declare your global variables here
unsigned int temper, bat, mot, res;
unsigned char imp=0x00, stl=0x00, pw=0x00, ch=0x00, rb=0x00;

// External Interrupt 0      .
interrupt [EXT_INT0] void ext_int0_isr(void)
{if (pw==0x44)
   pw=0x00;
else pw=0x44;
}

// External Interrupt 1      
interrupt [EXT_INT1] void ext_int1_isr(void)
{delay_ms(50);
if (pw<0x44) 
pw=0xff;
if (pw>0x44)
pw=0x00;}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{if (imp>0x0a)
{if (pw==0x44)         //
{switch (ch) {             //         
   case 0x20:{             //          
    ch++;                  //            
    PORTD&=0x1f;           //               
    PORTB&=0xae;           //
    PORTB|=0x10;}          //
   case 0x21:{             //       
    ch++;                  //          
    PORTB|=0x01;}          //             
   case 0x22:{             //                  
    ch++;                  //                      
    PORTD|=0x40;}          //                          
   case 0x23:{             //                            
    ch++;                  //       
    PORTD|=0x80;}          //       0.65635 
   case 0x24:{             //
    ch=0x20;
    PORTD|=0x20;}
   case 0x40:{
    ch++;
    PORTD&=0x1f;
    PORTB&=0xee;
    PORTB|=0x40;}
   case 0x41:{
    ch++;
    PORTB|=0x01;}
   case 0x42:{
    ch++;
    PORTD|=0x40;}
   case 0x43:{
    ch++;
    PORTD|=0x80;}
   case 0x44:{
    ch=0x40;
    PORTD|=0x20;}
   case 0x60:{
    ch++;
    PORTD&=0x1f;
    PORTB&=0xef;
    PORTB|=0x41;}
   case 0x61:{
    ch++;
    PORTD|=0x40;}
   case 0x62:{
    ch++;
    PORTD|=0x80;}
   case 0x63:{
    ch=0x60;
    PORTD|=0x20;}
   case 0x80:{
    ch++;
    PORTD&=0x1f;
    PORTB&=0xef;
    PORTB|=0x41;
    PORTD|=0x40;}
   case 0x81:{
    ch++;
    PORTD|=0x80;}
   case 0x82:{
    ch=0x80;
    PORTD|=0x20;}
   case 0xa0:{
    ch++;
    PORTD&=0x1f;
    PORTB&=0xef;
    PORTB|=0x41;
    PORTD|=0xc0;}
   case 0xa1:{
    ch=0xa0;
    PORTD|=0x20;} 
  case 0xf0:{
    ch++;
    PORTD&=0x1f;
    PORTB&=0xef;}
  case 0xf1:{
    ch=0xf0;
    PORTD|=0xe0;
    PORTB|=0x41;}    
    break;
    };
    }}
else imp++;
if (pw>0x44)
 {DDRB^=0xd1;
  DDRD^=0xe0;}
}

// Timer1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
// Place your code here

}

// Timer1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
// Place your code here

}

// Timer1 output compare B interrupt service routine
interrupt [TIM1_COMPB] void timer1_compb_isr(void)
{
// Place your code here

}

// Timer2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
// Place your code here

}

// Timer2 output compare interrupt service routine
interrupt [TIM2_COMP] void timer2_comp_isr(void)
{
// Place your code here

}

// Voltage Reference: Int., cap. on AREF
#define ADC_VREF_TYPE ((1<<REFS1) | (1<<REFS0) | (0<<ADLAR) | (0<<MUX3) | (0<<MUX2) | (0<<MUX1) | (0<<MUX0))

unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | ADC_VREF_TYPE;
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Function: Bit7=Out Bit6=Out Bit5=In Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=Out 
DDRB=(1<<DDB7) | (1<<DDB6) | (0<<DDB5) | (1<<DDB4) | (1<<DDB3) | (1<<DDB2) | (1<<DDB1) | (1<<DDB0);
// State: Bit7=0 Bit6=0 Bit5=T Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=0 
PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);

// Port C initialization
// Function: Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
DDRC=(0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (1<<DDC2) | (0<<DDC1) | (0<<DDC0);
// State: Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T 
PORTC=(0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);

// Port D initialization
// Function: Bit7=Out Bit6=Out Bit5=Out Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
DDRD=(1<<DDD7) | (1<<DDD6) | (1<<DDD5) | (0<<DDD4) | (1<<DDD3) | (0<<DDD2) | (0<<DDD1) | (0<<DDD0);
// State: Bit7=0 Bit6=0 Bit5=0 Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T 
PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (1<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
TCCR0=(1<<CS02) | (0<<CS01) | (1<<CS00);
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: CTC top=ICR1
// OC1A output: Clear on compare match
// OC1B output: Clear on compare match
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer Period: 1 us
// Output Pulse(s):
// OC1A Period: 1 us
// OC1B Period: 1 us
// Timer1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: On
TCCR1A=(1<<COM1A1) | (0<<COM1A0) | (1<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (0<<WGM10);
TCCR1B=(0<<ICNC1) | (0<<ICES1) | (1<<WGM13) | (1<<WGM12) | (0<<CS12) | (0<<CS11) | (1<<CS10);
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: CTC top=OCR2A
// OC2 output: Disconnected
// Timer Period: 0,033 ms
ASSR=0<<AS2;
TCCR2=(0<<PWM2) | (0<<COM21) | (0<<COM20) | (1<<CTC2) | (0<<CS22) | (0<<CS21) | (1<<CS20);
TCNT2=0x00;
OCR2=0x20;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=(1<<OCIE2) | (1<<TOIE2) | (0<<TICIE1) | (1<<OCIE1A) | (1<<OCIE1B) | (1<<TOIE1) | (1<<TOIE0);

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: On
// INT1 Mode: Any Change
GICR|=(1<<INT1) | (1<<INT0);
MCUCR=(0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (1<<ISC00);
GIFR=(1<<INTF1) | (1<<INTF0);

// USART initialization
// USART disabled
UCSRB=(0<<RXCIE) | (0<<TXCIE) | (0<<UDRIE) | (0<<RXEN) | (0<<TXEN) | (0<<UCSZ2) | (0<<RXB8) | (0<<TXB8);

// Analog Comparator initialization
// Analog Comparator: Off
// The Analog Comparator's positive input is
// connected to the AIN0 pin
// The Analog Comparator's negative input is
// connected to the AIN1 pin
ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);

// ADC initialization
// ADC Clock frequency: 125,000 kHz
// ADC Voltage Reference: Int., cap. on AREF
ADMUX=ADC_VREF_TYPE;
ADCSRA=(1<<ADEN) | (0<<ADSC) | (0<<ADFR) | (0<<ADIF) | (1<<ADIE) | (0<<ADPS2) | (1<<ADPS1) | (1<<ADPS0);
SFIOR=(0<<ACME);

// SPI initialization
// SPI disabled
SPCR=(0<<SPIE) | (0<<SPE) | (0<<DORD) | (0<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);

// TWI initialization
// TWI disabled
TWCR=(0<<TWEA) | (0<<TWSTA) | (0<<TWSTO) | (0<<TWEN) | (0<<TWIE);

// 1 Wire Bus initialization
// 1 Wire Data port: PORTC
// 1 Wire Data bit: 2
// Note: 1 Wire port settings are specified in the
// Project|Configure|C Compiler|Libraries|1 Wire menu.
w1_init();
// Global enable interrupts
#asm ("sei");
ICR1=0x03ff;
while (1)
      {
if( ds18b20_init( 0, 0, 45, DS18B20_9BIT_RES ) ) // .      
    temper=ds18b20_temperature( 0 ); // ,  
  //         
  if( temper>1000 ) { temper=4096-temper; temper=-temper; }  //     temper

bat=read_adc(5);
  
if (pw>0x44)
switch (bat) {
    case 0x0320: // 100%
        PORTD|=0x41;
        PORTB|=0xe0; 
    case 0x02f8:  // 80%
        PORTD|=0x41;
        PORTB|=0xc0;    
    case 0x02bc:  // 60% 
        PORTD|=0x41;                                          
        PORTB|=0x40;
    case 0x0280:  // 40% 
        PORTD|=0x41;
    case 0x0230:  // 20% 
        PORTD|=0x10;
    break;
    }; 
imp=0x00;
if (pw<0x01)       //
{imp=0x00;         //
delay_ms(700);     //
MCUCR|=0x40;       //
delay_ms(100);}    // 
if (pw>0x44)  //******************************   *********************************
{bat=read_adc(5);
 if (bat>0x0226) //    - 
    {OCR1BL=0xff;
    PORTB|=0x80;
    delay_ms(1);
    ADCSRA|=0x40;
 while ((ADCSRA&0x10)==0);
    delay_ms(1);
    ADCSRA|=0x40;            //     ;
 while ((ADCSRA&0x10)==0);   
    if (mot>0x0190)         //
    {OCR1BH--;}             // 
    if (mot<0x0190)         //
    {OCR1BH++;}             //
    }
 else             //   - 
    {OCR1BL=0x00;
    OCR1BH=0x00;
    pw=0x00;}
}
if (pw==0x44)            //   -  
    {OCR1BL=0x00;
    OCR1BH=0x00;
    PORTB|0x80; 
    ADMUX=0xc5; //ADC5
    ADCSRA|=0x40; //Start ADC
    while ((ADCSRA&0x10)==0);// 
    delay_ms(1);
    ADCSRA|=0x40;
    while ((ADCSRA&0x10)==0);// 
    delay_ms(1);
    ADCSRA|=0x40;
    while ((ADCSRA&0x10)==0);// 
    if (bat<0x0348)
    {if( ds18b20_init( 0, 0, 45, DS18B20_9BIT_RES ) ) // .      
    temper=ds18b20_temperature( 0 ); // ,  
  //*************************   *****************************************      
  if( temper>1000 ) { temper=4096-temper; temper=-temper; }  //     temper
    {if (0<temper<45)
      {if (15<temper<25)
       {if (0x0226<bat<0x0258)
        {if (stl<0x01)
         stl=0x10;
         if (res<0x0016)
          {OCR1AL++;}
         if (res>0x0016)  
          {OCR1AL--;}}
       if (0x0258<bat<0x0348)
        {if (res<0x0080)
         {OCR1AL++;}
         if (res>0x0080)
         {OCR1AL--;}}
       if ((bat>0x0347) & (0x00<stl<0x11))
        {if (res>0x0005)
          if (bat>0x0350)
           {OCR1AL--;}
          if (bat<0x0348)
           {OCR1AL++;}}} 
      else
       {if (0x0226<bat<0x0258)
        {if (stl<0x01)
         stl=0x10;
         if (res<0x0016)
          {OCR1AL++;}
         if (res>0x0016)  
          {OCR1AL--;}}
       if (0x0258<bat<0x0348)
        {if (res<0x0016)
         {OCR1AL++;}
         if (res>0x0016)
         {OCR1AL--;}}
       if ((bat>0x0347) & (0x00<stl<0x11))
        {if (res>0x0005)
          if (bat>0x0350)
           {OCR1AL--;}
          if (bat<0x0348)
           {OCR1AL++;}}}  
       }
    else
    {ch=0x20;
     OCR1AL=0x00;
     OCR1AH=0x00;}
    }}
    else
    {ch=0xf0;
     OCR1AL=0x00;
     OCR1AH=0x00;}}
}}
